This document shows you how to use the Resource Manager remote Model Context
Protocol (MCP) server to connect with AI applications including Antigravity,
ChatGPT, Claude, and custom applications you are developing.
The Resource Manager remote MCP server lets you search for
and identify all Google Cloud projects that you have the necessary permissions to
access, ensuring you have the correct identifiers before attempting more specific
resource configurations.

The tool returns a structured list containing the project ID, project number,
and the lifecycle state of the project.


The Resource Manager remote MCP server is enabled when you enable the
Resource Manager API.


[Model Context Protocol](https://modelcontextprotocol.io/docs/getting-started/intro)
(MCP) standardizes how large language models (LLMs) and AI applications or
agents connect to external data sources. MCP servers let you use their tools,
resources, and prompts to take actions and get updated data from their backend
service.

## What's the difference between local and remote MCP servers?

Local MCP servers
:   Typically run on your local machine and use the standard input
    and output streams (stdio) for communication between services on the same
    device.

Remote MCP servers
:   Run on the service's infrastructure and offer an HTTP
    endpoint to AI applications for communication between the AI MCP client and
    the MCP server. For more information about MCP architecture, see
    [MCP architecture](https://modelcontextprotocol.io/docs/learn/architecture).

## Stateless core

With
[MCP version 2026-07-28](https://modelcontextprotocol.io/specification/2026-07-28),
MCP changes from a bidirectional, stateful protocol to a stateless protocol.
Each MCP request is self-describing and can be routed using headers. There isn't
a need for the `initialize`/`initialized` handshake or `Mcp-Session-Id` because
each request includes all the information needed in HTTP headers or the `_meta`
parameter. MCP servers can request additional information required by a tool
through
[multi-round-trip requests (MRTR)](https://modelcontextprotocol.io/specification/latest/basic/patterns/mrtr).

To help route and process requests without parsing the request body, some MCP
headers are required, including the following:

- Headers that are required by the MCP specification such as the [protocol version header](https://modelcontextprotocol.io/specification/latest/basic/transports/streamable-http#protocol-version-header) and [standard request headers](https://modelcontextprotocol.io/specification/latest/basic/transports/streamable-http#standard-request-headers).
- [Custom headers](https://modelcontextprotocol.io/specification/latest/basic/transports/streamable-http#custom-headers-from-tool-parameters) that are defined by the MCP server. These headers are mirrored into HTTP headers from the tool's input schema using the `x-mcp-header` property. For example, an MCP server might define a custom header to specify the Google Cloud region or project ID.

For more information about MCP architecture, see the MCP version 2026-07-28
[specification](https://modelcontextprotocol.io/specification/2026-07-28) and
[key changes](https://modelcontextprotocol.io/specification/2026-07-28/changelog).

## Google and Google Cloud remote MCP servers

Google and Google Cloud remote MCP servers have the following features and benefits:

<br />

- Simplified, centralized discovery
- Managed global or regional HTTP endpoints
- Fine-grained authorization
- Optional prompt and response security with Model Armor protection
- Centralized audit logging

For information about other MCP servers and information about security
and governance controls available for Google Cloud MCP servers,
see [Google Cloud MCP servers overview](https://docs.cloud.google.com/mcp/overview.md.txt).

## Limitations

You can use IAM deny policies to block traffic to the
Resource Manager service and its MCP server. However, MCP-specific
IAM attributes and `toolUser` permissions can't be used to
restrict tool access for this server.

## Before you begin

<br />

## Authentication and authorization

The Resource Manager remote MCP server uses the [OAuth 2.0](https://developers.google.com/identity/protocols/oauth2) protocol with [Identity and Access Management (IAM)](https://docs.cloud.google.com/iam/docs/overview.md.txt) for authentication and authorization. All [Google Cloud identities](https://docs.cloud.google.com/docs/authentication/identity-products.md.txt) are supported for authentication to MCP servers.

The Resource Manager MCP server doesn't accept API keys for authentication.

We recommend creating a separate identity for agents using MCP tools so that
access to resources can be controlled and monitored. For more information on
authentication, see [Authenticate to MCP servers](https://docs.cloud.google.com/mcp/authenticate-mcp.md.txt).

## Resource Manager MCP OAuth scopes

OAuth 2.0 uses scopes and credentials to determine if an authenticated
principal is authorized to take a specific action on a resource. For more
information about OAuth 2.0 scopes at Google, read
[Using OAuth 2.0 to access Google APIs](https://developers.google.com/identity/protocols/oauth2).

Resource Manager has the following MCP tool OAuth scopes:

| Scope URI for gcloud CLI | Description |
|---|---|
| `https://www.googleapis.com/auth/cloudresourcemanager.read-only` | Only allows access to read data. |
| `https://www.googleapis.com/auth/cloudresourcemanager.read-write` | Allows access to read and modify data. |

Additional scopes might be required on the resources accessed during a tool
call. To view a list of scopes required for
Resource Manager, see
[Resource Manager API](https://developers.google.com/identity/protocols/oauth2/scopes#cloudresourcemanager).

## Configure an MCP client to use the Resource Manager MCP server

AI applications and agents, such as Claude or Antigravity, can instantiate an MCP client that connects to a single MCP server. An AI application can have multiple clients that connect to different MCP servers. If your application isn't listed in the [client-specific guidance](https://docs.cloud.google.com/mcp/configure-mcp-ai-application.md.txt#client-specific-guidance), then you can use the following information to connect from most applications.

In your AI application, look for a way to add or connect to a remote MCP server.
For the Resource Manager MCP server, enter the following
information as required:

- **Server name**: Resource Manager MCP server
- **Server URL** or **Endpoint**: https://cloudresourcemanager.googleapis.com/mcp
- **Transport** : [Streamable HTTP](https://modelcontextprotocol.io/specification/latest/basic/transports/streamable-http)
- **Authentication details** : depending on how you want to authenticate, you can enter your Google Cloud credentials, your OAuth Client ID and secret, or an agent identity and credentials. For more information about authentication, see [Authenticate to MCP servers](https://docs.cloud.google.com/mcp/authenticate-mcp.md.txt).
- **OAuth scope** : the [OAuth 2.0 scope](https://developers.google.com/identity/protocols/oauth2/scopes) that you want to use when connecting to the Resource Manager MCP server.

### Redirect URIs

For web-based applications, and some desktop applications, you must allowlist a
redirect URI when you create a client ID and secret for authentication.
Redirect URIs are used by the authorization server to send tokens
to your application. Your application's documentation should specify the
redirect URI that you must use. [Custom redirect URIs](https://developers.google.com/identity/protocols/oauth2/native-app#redirect-uri_custom-scheme)
aren't supported.
For application-specific guidance about setting up and connecting to MCP server, see [Client-specific guidance](https://docs.cloud.google.com/mcp/configure-mcp-ai-application.md.txt#client-specific-guidance).

For more general guidance, see the following resources:

- [Connect to remote MCP servers](https://modelcontextprotocol.io/docs/develop/connect-remote-servers).
- [Configure MCP in an AI application](https://docs.cloud.google.com/mcp/configure-mcp-ai-application.md.txt).

## Available tools

To view details of available MCP tools and their descriptions for the
Resource Manager MCP server, see the
[Resource Manager MCP reference](https://docs.cloud.google.com/resource-manager/reference/mcp.md.txt).

### List tools

Use the [MCP inspector](https://modelcontextprotocol.io/docs/tools/inspector) to list tools, or send a
`tools/list` HTTP request directly to the Resource Manager
remote MCP server. The `tools/list` method doesn't require authentication.

    curl -X POST https://cloudresourcemanager.googleapis.com/TOOLSET_ENDPOINT \
        -H 'Content-Type: application/json' \
        -H 'Accept: application/json' \
        -H 'MCP-Protocol-Version: MCP_PROTOCOL_VERSION' \
        -H 'Mcp-Method: tools/list' \
        -d '{
          "jsonrpc": "2.0",
          "id": 1,
          "method": "tools/list",
          "params": {
            "_meta": {
              "io.modelcontextprotocol/protocolVersion": "MCP_PROTOCOL_VERSION",
              "io.modelcontextprotocol/clientCapabilities": {
                "extensions": {
                  "io.modelcontextprotocol/ui": {
                    "mimeTypes": ["text/html;profile=mcp-app"]
                  }
                }
              }
            }
          }
        }'

Replace the following:

- <var translate="no">`TOOLSET_ENDPOINT`</var>: the remainder of the MCP endpoint after the service name. For example, for Resource Manager, this might be `mcp/toolset-name`.
- <var translate="no">`MCP_PROTOCOL_VERSION`</var>: the MCP protocol version. For example, `2026-07-28`.

## Sample use cases

The [`search_projects` tool in the Resource Manager remote MCP server](https://docs.cloud.google.com/resource-manager/reference/mcp/search_projects.md.txt) lets AI agents dynamically
discover and identify all Google Cloud projects that you have the necessary permissions to
access so they can execute commands in other tools.

The tool returns a structured list containing the project ID, project number,
and the lifecycle state of the project. The following are sample use cases for the Resource Manager
MCP server:

- **Resource inventory and accessibility audits**: List and summarize the active
  cloud projects accessible to you.

  User prompt: "List all my active Google Cloud projects."

  Agent action: The agent sends a search query to the MCP server to
  retrieve and display a summarized list of all active projects under your
  credentials.
- **Targeted parent-based searches**: Retrieve projects located within a
  specific folder or organization to narrow the scope of a request.

  User prompt: "Find all projects under Folder 223."

  Agent action: The agent executes a tool call with the query
  `parent:folders/223` to return a list of projects within that
  administrative boundary.
- **Implicit context resolution**: When you ask for information about a
  resource without providing a specific project ID, the agent can resolve the
  context automatically.

  User prompt: "Check the status of my 'payment-processor' service."

  Agent action: The agent recognizes that a `project_id` is missing for the
  Cloud Run tool. It uses the `search_projects` tool to find projects
  with `payment` in the name, identifies likely projects (such as
  `payment-prod-123`), and asks you for confirmation before proceeding.
- **Environment-specific discovery**: You can find projects filtered by
  specific environments or organizational structures without leaving the chat
  interface.

  User prompt: "Which projects do I have access to in the staging environment?"

  Agent action: The agent performs a search operation for all projects labeled
  or named `staging` that you have permission to view and returns the specific
  project IDs.

### Customize LLM behavior

The `search_projects` tool is versatile, but LLMs might not always know when to
query your Google Cloud hierarchy. To call the tool in specific scenarios,
provide custom context in a Markdown file, for example,
`~/.gemini/GEMINI.md` or a project-level `AGENTS.md`.

## What's next

- Read the [Resource Manager MCP reference documentation](https://docs.cloud.google.com/resource-manager/reference/mcp.md.txt).
- Learn more about [Google Cloud MCP servers](https://docs.cloud.google.com/mcp/overview.md.txt).